/*============================================================================*
 *  FILE: 
 *     dbMgr.c
 *
 *  Description: 
 *     f[^x[X}l[W
 *===========================================================================*/
#define DBMGR_C
#include "local.h"

/*-------------------------------------------------------------------------*/
/*   Function : aplCompareF                                                */
/*                                                (\[eBOpr֐) */
/*                        NNsif[^x[X̍\̂gpĕבւ */
/*-------------------------------------------------------------------------*/
static Int16 aplCompareF_Subject(void *rec1, void *rec2, Int16 other,
                                 SortRecordInfoPtr       rec1SortInfo,
                                 SortRecordInfoPtr       rec2SortInfo, 
                                 MemHandle               appInfoH)
{
    NNshSubjectDatabase *p1, *p2;
    Int16                ret;
    UInt8                sts1, sts2;
    
    p1 = (NNshSubjectDatabase *)rec1;
    p2 = (NNshSubjectDatabase *)rec2;

    // CɓXȂADxɕבւ
    sts1 = (p1->msgAttribute & NNSH_MSGATTR_FAVOR);
    sts2 = (p2->msgAttribute & NNSH_MSGATTR_FAVOR);
    if (sts1 != sts2)
    {
        return (sts1 - sts2);
    }

#ifdef USE_SORT_BBS_NORMAL_ORDER
    // т(AZ)ɂꍇɂ́ÃWbNLɂ
    // (ʏ͋tŃ\[g)
    if ((p1->boardNick[0] == '!' && p2->boardNick[0] != '!') ||
        (p1->boardNick[0] != '!' && p2->boardNick[0] == '!'))
    {
        NNshSubjectDatabase *p3;

        /* ǂ炩 !GikoShippo ̏ꍇ́A\[gʂ𔽓] */
        /* iKOɏW܂邩...j                                   */
        p3 = p1;
        p1 = p2;
        p2 = p3;
    }
    ret = StrCompare(p2->boardNick, p1->boardNick);
#else
    ret = StrCompare(p1->boardNick, p2->boardNick);
#endif
    if (ret != 0)
    {
        // {[hŃ\[g
        return (ret);
    }

    // {[hƂŁAԂقȂƂ
    if (p1->state != p2->state)
    {
        switch (p1->state)
        {
          case NNSH_SUBJSTATUS_NEW:
          case NNSH_SUBJSTATUS_UPDATE:
          case NNSH_SUBJSTATUS_REMAIN:
          case NNSH_SUBJSTATUS_ALREADY: 
          case NNSH_SUBJSTATUS_UNKNOWN: 
            if (p2->state == NNSH_SUBJSTATUS_NOT_YET)
            {
                // ǂ͌
                return (1);
            }
            break;
   
          case NNSH_SUBJSTATUS_NOT_YET:
          default:
            if (p2->state != NNSH_SUBJSTATUS_NOT_YET)
            {
                // ǂ͌
                return (-1);
            }
            break;
        }
    }

    /*** XԍŃ\[g ***/
    return (StrCompare(p2->threadFileName, p1->threadFileName));
}

/*-------------------------------------------------------------------------*/
/*   Function : aplCompareF                                                */
/*                                                (\[eBOpr֐) */
/*                         DBotheroCgڂɁuŁvkey  */
/*                                                         ̂ƂB*/
/*-------------------------------------------------------------------------*/
static Int16 aplCompareF_Char(void *rec1, void *rec2, Int16 other,
                              SortRecordInfoPtr       rec1SortInfo,
                              SortRecordInfoPtr       rec2SortInfo, 
                              MemHandle               appInfoH)
{
    Char *str1, *str2;

    str1 = ((Char *) rec1) + other;
    str2 = ((Char *) rec2) + other;
    return (StrCompare(str1, str2));
}

/*-------------------------------------------------------------------------*/
/*   Function : aplCompareF_UInt32                                         */
/*                                                (\[eBOpr֐) */
/*                         DBotheroCgڂɁuUInt32Łvkey  */
/*                                                         ̂ƂB*/
/*-------------------------------------------------------------------------*/
static Int16 aplCompareF_UInt32(void *rec1, void *rec2, Int16 other,
                                SortRecordInfoPtr       rec1SortInfo,
                                SortRecordInfoPtr       rec2SortInfo, 
                                MemHandle               appInfoH)
{
    Char   *loc1,  *loc2;
    UInt32 *data1, *data2;

    loc1  = ((Char *) rec1) + other;
    loc2  = ((Char *) rec2) + other;

    data1 = (UInt32 *) loc1;
    data2 = (UInt32 *) loc2;

    return (*data1 - *data2);
}

/*-------------------------------------------------------------------------*/
/*   Function : aplCompareF_UInt16                                         */
/*                                                (\[eBOpr֐) */
/*                     key擪otheroCgڂuUInt16Łv  */
/*                                                         ̂ƂB*/
/*-------------------------------------------------------------------------*/
static Int16 aplCompareF_UInt16(void *rec1, void *rec2, Int16 other,
                                SortRecordInfoPtr       rec1SortInfo,
                                SortRecordInfoPtr       rec2SortInfo, 
                                MemHandle               appInfoH)
{
    Char   *loc1,  *loc2;
    UInt16 *data1, *data2;

    loc1  = ((Char *) rec1) + other;
    loc2  = ((Char *) rec2) + other;

    data1 = (UInt16 *) loc1;
    data2 = (UInt16 *) loc2;

    return (*data1 - *data2);
}

/*-------------------------------------------------------------------------*/
/*   Function : searchRecordSub                                            */
/*                                                        (R[h) */
/*-------------------------------------------------------------------------*/
static Err searchRecordSub(DmOpenRef dbRef, void *target, UInt16 keyType, 
                           UInt16   offset, UInt16 *idx,  MemHandle *hnd)
{
    UInt16     nofData, start, end, mid;
    Int16      chk;
    MemHandle  dataH;
    Char      *data;

    // 镶LXg
    data = (Char *)target;
    data = data + offset;

    // f[^[猟s
    nofData = DmNumRecords(dbRef);
    if (nofData == 0)
    {
        return (~errNone - 5);
    }

    // QŎw肳ꂽf[^o^Ă邩`FbN
    mid   = 0;
    start = 0;
    end   = nofData;
    while (start <= end)
    {
        mid = start + (end - start) / 2;
        dataH = DmQueryRecord(dbRef, mid);
        if (dataH == 0)
        {
            // ȂI (Ŕ͗l)
            return (~errNone);
        }

        // w肳ꂽL[ɂāA`FbN@ς
        data = (Char *) MemHandleLock(dataH);
        data = data + offset;        // offsetȂAAA
        switch (keyType)
        {
          case NNSH_KEYTYPE_UINT32:
            chk  = *((UInt32 *) data) - *((UInt32 *) target);
            break;

          case NNSH_KEYTYPE_UINT16:
            chk  = *((UInt16 *) data) - *((UInt16 *) target);
            break;

          case NNSH_KEYTYPE_CHAR:
          default:
            chk  = StrCompare(data, (Char *) target);
            break;
        }
        if (chk == 0)
        {
            // I(f[^܂邲ƃRs[)
            MemHandleUnlock(dataH);
            *idx  = mid;
            *hnd  = dataH;
            return (errNone);
        }
        MemHandleUnlock(dataH);
        if (chk < 0)
        {
            start = mid + 1;
        }
        else
        {
            end   = mid - 1;
        }
    }
    return (~errNone - 4);
}

/*=========================================================================*/
/*   Function : DeleteDB_wCreator                                          */
/*                                    f[^x[X̍폜(NG[^IDw) */
/*=========================================================================*/
Err DeleteDB_wCreator(Char *dbName, UInt16 chkVer, UInt32 creator, UInt32 type)
{
    LocalID    dbId;
    UInt16     dbVersion;

    // NG[^IDw肳ĂȂꍇɂ́AftHgcreatorIDgp
    if (creator == 0)
    {
        creator = SOFT_CREATOR_ID;
    }
    if (type == 0)
    {
        type    = SOFT_DBTYPE_ID;
    }

    // f[^x[X݂邩mFB
    dbId      = DmFindDatabase(0, dbName);
    if (dbId != 0)
    {
        // f[^x[X̃o[Wԍ擾
        (void) DmDatabaseInfo(0, dbId, NULL, NULL, &dbVersion, NULL, 
                              NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        if (dbVersion == chkVer)
        {
            // f[^x[X̃o[WvƂ̂ݍ폜
            (void) DmDeleteDatabase(0, dbId);
            return (errNone);
        }
    }
    // f[^x[X̍폜sȂƂɂ́AG[
    return (~errNone);
}

/*=========================================================================*/
/*   Function : OpenDB_wCreator                                            */
/*                                f[^x[X̃I[v(NG[^IDw) */
/*=========================================================================*/
Err OpenDB_wCreator(Char *dbName, UInt16 chkVer, UInt32 creator, UInt32 type,
                                             Boolean erase, DmOpenRef *dbRef)
{
    LocalID    dbId;
    UInt16     dbVersion;

    // NG[^IDw肳ĂȂꍇɂ́AftHgcreatorIDgp
    if (creator == 0)
    {
        creator = SOFT_CREATOR_ID;
    }
    if (type == 0)
    {
        type    = SOFT_DBTYPE_ID;
    }

    // f[^x[X݂邩mFB
    *dbRef    = 0;
    dbId      = DmFindDatabase(0, dbName);
    if (dbId != 0)
    {
        // f[^x[X̃o[Wԍ擾
        (void) DmDatabaseInfo(0, dbId, NULL, NULL, &dbVersion, NULL, 
                              NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        if ((dbVersion < chkVer)||(erase == true))
        {
            // f[^x[X̃o[WÂƂA܂͏[h́A
            // f[^x[X폜
            (void) DmDeleteDatabase(0, dbId);
            dbId = 0;
        }
    }

    // f[^x[X݂ȂƂ
    if (dbId == 0)
    {
        // f[^x[XVK쐬
        (void) DmCreateDatabase(0, dbName, creator, type, false);

        dbId      = DmFindDatabase(0, dbName);
        if (dbId != 0)
        {
            // DBɃo[Wԍݒ
            dbVersion = chkVer;
            (void) DmSetDatabaseInfo(0, dbId, NULL,NULL, &dbVersion, NULL,
                                     NULL,NULL,NULL,NULL,NULL,NULL,NULL);
        }
    }

    // f[^x[X̃I[v
    *dbRef = DmOpenDatabase(0 , dbId, dmModeReadWrite);

    // G[̔
    if (*dbRef == 0)
    {
        return (~errNone);
    }
    return (errNone);
}

/*==========================================================================*/
/*  OpenDatabase_NNsh : f[^x[XANZX̏                        */
/*                                                                          */
/*==========================================================================*/
void OpenDatabase_NNsh(Char *dbName, UInt16 chkVersion, DmOpenRef *dbRef)
{
    LocalID dbId;
    UInt16  dbVersion;

    // f[^x[X݂邩mFB
    *dbRef    = 0;
    dbVersion = 0;
    dbId      = DmFindDatabase(0, dbName);
    if (dbId != 0)
    {
        // f[^x[X̃o[Wԍ擾
        (void) DmDatabaseInfo(0, dbId, NULL, NULL, &dbVersion, NULL, 
                              NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        if (dbVersion < chkVersion)
        {
            // f[^x[X̃o[WÂƂ́Af[^x[X폜
            (void) DmDeleteDatabase(0, dbId);
            dbId = 0;
        }
    }

    // f[^x[X݂ȂƂ
    if (dbId == 0)
    {
        // f[^x[XVK쐬
        (void) DmCreateDatabase(0, dbName, 
                                SOFT_CREATOR_ID, SOFT_DBTYPE_ID, false);

        dbId      = DmFindDatabase(0, dbName);
        if (dbId != 0)
        {
            // DBɃo[Wԍݒ
            dbVersion = chkVersion;
            (void) DmSetDatabaseInfo(0, dbId, NULL,NULL, &dbVersion, NULL,
                                     NULL,NULL,NULL,NULL,NULL,NULL,NULL);
        }
    }

    // f[^x[X̃I[v
    *dbRef = DmOpenDatabase(0 , dbId, dmModeReadWrite);

    return;
}

/*==========================================================================*/
/*  closeDatabase_NNsh() : f[^x[XN[Y                       */
/*                                                                          */
/*==========================================================================*/
void CloseDatabase_NNsh(DmOpenRef dbRef)
{
    // DBI[vłĂCLOSEB
    if (dbRef != 0)
    {
        (void) DmCloseDatabase(dbRef);
        dbRef = 0;
    }
    return;
}

/*=========================================================================*/
/*   Function : QsortRecord_NNsh                                           */
/*                                                (R[h̃\[eBO) */
/*=========================================================================*/
void QsortRecord_NNsh(DmOpenRef dbRef, UInt16 keyType, UInt16 offset)
{

    // NCbN\[gd|
    switch (keyType)
    {

      case NNSH_KEYTYPE_UINT32:
        (void) DmQuickSort(dbRef, (DmComparF *) aplCompareF_UInt32, offset);
        break;

      case NNSH_KEYTYPE_UINT16:
        (void) DmQuickSort(dbRef, (DmComparF *) aplCompareF_UInt16, offset);
        break;

      case NNSH_KEYTYPE_SUBJECT:
        (void) DmQuickSort(dbRef, (DmComparF *) aplCompareF_Subject, offset);
        break;

      case NNSH_KEYTYPE_CHAR:
      default:
        (void) DmQuickSort(dbRef, (DmComparF *) aplCompareF_Char, offset);
        break;
    }
    return;
}

/*=========================================================================*/
/*   Function : IsortRecord_NNsh                                           */
/*                                                (R[h̃\[eBO) */
/*=========================================================================*/
void IsortRecord_NNsh(DmOpenRef dbRef, UInt16 keyType, UInt16 offset)
{

    // }\[gd|
    switch (keyType)
    {
      case NNSH_KEYTYPE_UINT32:
        (void) DmInsertionSort(dbRef, (DmComparF *)aplCompareF_UInt32, offset);
        break;

      case NNSH_KEYTYPE_UINT16:
        (void) DmInsertionSort(dbRef, (DmComparF *)aplCompareF_UInt16, offset);
        break;

      case NNSH_KEYTYPE_SUBJECT:
        (void) DmInsertionSort(dbRef, (DmComparF *)aplCompareF_Subject,offset);
        break;

      case NNSH_KEYTYPE_CHAR:
      default:
        (void) DmInsertionSort(dbRef, (DmComparF *)aplCompareF_Char, offset);
        break;
    }
    return;
}

/*=========================================================================*/
/*   Function : EntryRecord_NNsh                                           */
/*                                               (ca̐擪Ƀf[^o^)  */
/*=========================================================================*/
Err EntryRecord_NNsh(DmOpenRef dbRef, UInt16 size, void *recordData)
{
    MemHandle  newRecH;
    UInt16     index;
    void      *dbP;

    // R[h̐VKǉ
    index   = 0;
    newRecH = DmNewRecord(dbRef, &index, size + sizeof(UInt32));
    if (newRecH == 0)
    {
        // R[hǉG[
        return (DmGetLastErr());
    }

    // R[hɃf[^
    dbP = MemHandleLock(newRecH);
    DmWrite(dbP, 0, recordData, size);
    MemHandleUnlock(newRecH);

    // R[hiύXIj
    DmReleaseRecord(dbRef, index, true);

    return (errNone);
}

/*=========================================================================*/
/*   Function : IsExistRecord_NNsh                                         */
/*                                                (R[h̑݃`FbN) */
/*=========================================================================*/
Err IsExistRecord_NNsh(DmOpenRef dbRef, void   *target,  UInt16 keyType,
                       UInt16 offset,   UInt16 *index)
{
    MemHandle  dataH;

    *index  = 0;
    dataH   = 0;
    return (searchRecordSub(dbRef, target, keyType, offset, index, &dataH));
}

/*=========================================================================*/
/*   Function : IsExistRecordRR_NNsh                                       */
/*                     (R[h̑݃`FbN - 擪疖܂łPÂ) */
/*=========================================================================*/
Err IsExistRecordRR_NNsh(DmOpenRef dbRef, void   *target,  UInt16 keyType,
                       UInt16 offset,   UInt16 *index)
{
    UInt16     nofData, loop;
    MemHandle  dataH;
    Int16      chk;
    Char      *data;

    // f[^[猟s
    nofData = DmNumRecords(dbRef);
    if (nofData == 0)
    {
        return (~errNone - 5);
    }

    for (loop = 0; loop < nofData; loop++)
    {
        dataH = DmQueryRecord(dbRef, loop);
        if (dataH == 0)
        {
            // ȂI (Ŕ͗l)
            return (~errNone);
        }
        // w肳ꂽL[ɂāA`FbN@ς
        data = (Char *) MemHandleLock(dataH);
        data = data + offset;  // ItZbg
        switch (keyType)
        {
          case NNSH_KEYTYPE_UINT32:
            chk  = *((UInt32 *) data) - *((UInt32 *) target);
            break;

          case NNSH_KEYTYPE_UINT16:
            chk  = *((UInt16 *) data) - *((UInt16 *) target);
            break;

          case NNSH_KEYTYPE_CHAR:
          default:
            chk  = StrCompare(data, (Char *) target);
            break;
        }
        MemHandleUnlock(dataH);
        if (chk == 0)
        {
            // I
            *index  = loop;
            return (errNone);
        }     
    }
    *index = 0;
    return (~errNone - 4);
}

/*=========================================================================*/
/*   Function : SearchRecord_NNsh                                          */
/*                                                        (R[h) */
/*=========================================================================*/
Err SearchRecord_NNsh(DmOpenRef dbRef, void *target, UInt16 keyType,
                      UInt16 offset, UInt16 size, void *matchedData,
                      UInt16 *index)
{
    Err        ret;
    MemHandle  dataH;
#ifdef COPY_SELF
    Char      *sc,  *ds;
    UInt32    *src, *dest;
    UInt16     start;
#else
    UInt32    *src;
#endif

    *index = 0;
    dataH  = 0;

    ret    = searchRecordSub(dbRef, target, keyType, offset, index, &dataH);
    if (ret != errNone)
    {
        // f[^炸
        return (ret);
    }
    if (dataH == 0)
    {
        // nhُ
        return ((~errNone) - 2);
    }

    src = (UInt32 *) MemHandleLock(dataH);
    if (src == NULL)
    {
        // |C^ُ
        return ((~errNone) - 3);
    }

    // f[^܂邲ƃRs[ĉ
#ifdef COPY_SELF
    MemSet(matchedData, size, 0x00);
    dest   = (UInt32 *) matchedData;
    for (start = 0; start < (size - sizeof(UInt32));
         start = start + sizeof(UInt32))
    {
        *dest++ = *src++;
    }
    for (sc = (Char *) src, ds = (Char *) dest;start < size;
         start = start + sizeof(Char))
    {
         *ds++ = *sc++;
    }
#else
    MemMove(matchedData, src, size);
#endif

    MemHandleUnlock(dataH);
    return (errNone);
}

/*=========================================================================*/
/*   Function : DeleteRecord_NNsh                                          */
/*                                                    (YR[h폜) */
/*=========================================================================*/
Err DeleteRecord_NNsh(DmOpenRef dbRef, void  *target,
                      UInt16 keyType,  UInt16 offset)
{
    Err       ret;
    UInt16    index;
    MemHandle dataH;

    index = 0;
    dataH = 0;
    ret = searchRecordSub(dbRef, target, keyType, offset, &index, &dataH);
    if (ret != errNone)
    {
        return (errNone + 1);
    }

    return (DmRemoveRecord(dbRef, index));
}

/*=========================================================================*/
/*   Function : DeleteRecordIDX_NNsh                                       */
/*                                                    (YR[h폜) */
/*=========================================================================*/
Err DeleteRecordIDX_NNsh(DmOpenRef dbRef, UInt16 index)
{
    // f[^I[oĂ邩mF
    if (index >= DmNumRecords(dbRef))
    {
        return (~errNone);
    }
    return (DmRemoveRecord(dbRef, index));
}

/*=========================================================================*/
/*   Function : GetRecord_NNsh                                             */
/*                                          (R[hCfbNXŊl) */
/*=========================================================================*/
Err GetRecord_NNsh(DmOpenRef dbRef, UInt16 index,
                   UInt16 size, void *matchedData)
{
    MemHandle  dataH;
#ifdef COPY_SELF
    UInt16     start;
    UInt32    *src, *dest;
    Char      *sc,  *ds;
#else
    UInt32    *src;
#endif

    // f[^I[oĂ邩mF
    if (index >= DmNumRecords(dbRef))
    {
        return (~errNone - 6);
    }

    dataH = DmQueryRecord(dbRef, index);
    if (dataH == 0)
    {
        // ȂI
        return (~errNone);
    }
    src = (UInt32 *) MemHandleLock(dataH);
    if (src == NULL)
    {
        // |C^ُ
        return ((~errNone) - 3);
    }

    // f[^܂邲ƃRs[ĉ
#ifdef COPY_SELF
    MemSet(matchedData, size, 0x00);
    dest   = (UInt32 *) matchedData;
    for (start = 0; start < (size - sizeof(UInt32));
         start = start + sizeof(UInt32))
    {
        *dest++ = *src++;
    }
    for (sc = (Char *) src, ds = (Char *) dest;start < size;
         start = start + sizeof(Char))
    {
         *ds++ = *sc++;
    }
#else
    MemMove(matchedData, src, size);
#endif
    MemHandleUnlock(dataH);
    return (errNone);
}

/*=========================================================================*/
/*   Function : GetRecordReadOnly_NNsh                                     */
/*                                          (R[hCfbNXŊl) */
/*=========================================================================*/
Err GetRecordReadOnly_NNsh(DmOpenRef dbRef, UInt16 index,
                           MemHandle *dataH, void **record)
{
    // f[^I[oĂ邩mF
    if (index >= DmNumRecords(dbRef))
    {
        return (~errNone - 6);
    }

    *dataH = DmQueryRecord(dbRef, index);
    if (*dataH == 0)
    {
        // ȂI
        return (~errNone);
    }

    // ̈bN
    *record = MemHandleLock(*dataH);
    if (record == NULL)
    {
        // |C^ُ
        return ((~errNone) - 3);
    }
    return (errNone);
}

/*=========================================================================*/
/*   Function : ReleaseRecordReadOnly_NNsh                                 */
/*                                                (R[hǂݏoI) */
/*=========================================================================*/
Err ReleaseRecordReadOnly_NNsh(DmOpenRef dbRef, MemHandle dataH)
{
    if (dataH != 0)
    {
        MemHandleUnlock(dataH);
    }
    return (errNone);
}

/*=========================================================================*/
/*   Function : UpdateRecord_NNsh                                          */
/*                                          (R[hCfbNXōXV) */
/*=========================================================================*/
Err UpdateRecord_NNsh(DmOpenRef dbRef, UInt16 index, 
                      UInt16 size, void *updateData)
{
    MemHandle recH;
    void     *dbP;

    recH = DmGetRecord(dbRef, index);
    if (recH == 0)
    {
        // R[hQƃG[
        return (DmGetLastErr());
    }

    // R[hɃf[^
    dbP = MemHandleLock(recH);
    DmWrite(dbP, 0, updateData, size);
    MemHandleUnlock(recH);

    // R[hiύXIj
    DmReleaseRecord(dbRef, index, true);

    return (errNone);
}

/*=========================================================================*/
/*   Function : GetRecordID_NNsh                                           */
/*                                      (R[h̃j[NID擾) */
/*=========================================================================*/
Err GetRecordID_NNsh(DmOpenRef dbRef, UInt16 index, UInt32 *recId)
{
    return (DmRecordInfo(dbRef, index, NULL, recId, NULL));
}

/*=========================================================================*/
/*   Function : GetRecordIndexFromRecordID_NNsh                            */
/*                  (R[h̃j[NIDCfbNXԍ擾) */
/*=========================================================================*/
Err GetRecordIndexFromRecordID_NNsh(DmOpenRef dbRef, UInt32 recId, UInt16 *index)
{
    return (DmFindRecordByID(dbRef, recId, index));
}

/*==========================================================================*/
/*  GetDBCount_NNsh : f[^x[Xɓo^Ăf[^      */
/*                                                                          */
/*==========================================================================*/
void GetDBCount_NNsh(DmOpenRef dbRef, UInt16 *count)
{
    *count = DmNumRecords(dbRef);
    return;
}

/*==========================================================================*/
/*  GetDBInfo_NNsh : f[^x[X̏̎擾                               */
/*                                                                          */
/*==========================================================================*/
Err GetDBInfo_NNsh(Char *dbName, NNshDBInfo *info)
{
    LocalID dbId;
    
    dbId = DmFindDatabase(0, dbName);

    // f[^x[X݂ȂƂ
    if (dbId == 0)
        return(~errNone);

    return(DmDatabaseInfo(0, dbId,
                          info->nameP, info->attributesP,
                          info->versionP, info->crDateP,
                          info->modDateP, info->bckUpDateP,
                          info->modNumP, info->appInfoIDP,
                          info->sortInfoIDP, info->typeP,
                          info->creatorP));
}

/*==========================================================================*/
/*  GetExistRecordList : X擾ĂXbhDB̃R[h̎擾 */
/*  (ꗗŏdȂ߂̏擾)                                      */
/*==========================================================================*/
Boolean GetExistRecordList(DmOpenRef dbRef, Char *boardNick, MemHandle *listH, UInt16 *threadNum)
{
    UInt16 nofRecords, i;
    MemHandle            recH;
    NNshSubjectDatabase *chkDb;
    Char *buf;
    UInt32 areaSize, size;
    
    size       = 0;
    areaSize   = 0;
    *threadNum = 0;
    
    // o^ς݃R[hl
    GetDBCount_NNsh(dbRef, &nofRecords);

    // boardNick ̃Xi[Ă DB ̐擪TiẌ̊mہj
    for (i = 0; i < nofRecords; i++)
    {
        (void)GetRecordReadOnly_NNsh(dbRef, i, &recH, (void **)&chkDb);
        if (StrCompare(chkDb->boardNick, boardNick) == 0)
        {
            areaSize = MAX_THREADFILENAME + 2 + 6; // 6̓Xi[p̈(4 + 2) 
            *listH   = MemHandleNew(areaSize);
            if(*listH == 0)
            {
                // ̈mێs
                return (false);
            }

            // X̃t@CƃXL^
            buf      = MemHandleLock(*listH);
            MemSet (buf, areaSize, 0x00);
            StrCopy(buf, chkDb->threadFileName);
            switch (chkDb->state)
            {
              case NNSH_SUBJSTATUS_UPDATE:
              case NNSH_SUBJSTATUS_REMAIN:
              case NNSH_SUBJSTATUS_ALREADY:
              case NNSH_SUBJSTATUS_NEW:
                // X擾ς݂̏ꍇ́ADB̒l𔽉f
                NUMCATI(buf, chkDb->maxLoc);
                break;

              default:
                // 擾̏ꍇɂ̓[i[
                NUMCATI(buf, 0);
                break;
            }

            // X̃t@C̃Zp[^Ƃ '\x0a' gp
            size = StrLen(buf);
            buf[size] = '\x0a';

            MemHandleUnlock(*listH);
            (*threadNum)++;
            
            ReleaseRecordReadOnly_NNsh(dbRef, recH);
            break;
        }
        ReleaseRecordReadOnly_NNsh(dbRef, recH);
    }

    // DB ɓĂȂ false ԂB
    if (*threadNum == 0)
    {
        return (false);
    }
    
    // boardNick ̃Xi[Ă΁AXgɒǉ
    for (i += 1; i < nofRecords; i++)
    {
         (void)GetRecordReadOnly_NNsh(dbRef, i, &recH, (void **)&chkDb);
        
        if (!StrCompare(chkDb->boardNick, boardNick))
        {
            // pos ̓Zp[^̈ʒuĂ邽߁A
            // pos + 1 + len + 1 -> pos + len + 2 ̗̈mۂ
            areaSize = size + MAX_THREADFILENAME + 2 + 6; // 6̓Xi[p̈(4 + 2) 
            if (MemHandleResize(*listH, areaSize) != errNone)
            {
                // ̈g厸s...
                MemHandleFree(*listH);
                ReleaseRecordReadOnly_NNsh(dbRef, recH);
                return(false);
            }
            // X̃t@Cۑ            
            buf = MemHandleLock(*listH);
            MemSet (&buf[size + 1], (areaSize - (size + 1)), 0x00);
            StrCat (buf, chkDb->threadFileName);
            NUMCATI(buf, chkDb->maxLoc);

            // X̃t@C̃Zp[^Ƃ '\x0a' gp
            size = StrLen(buf);
            buf[size] = '\x0a';

            MemHandleUnlock(*listH);
            (*threadNum)++;
        }
        ReleaseRecordReadOnly_NNsh(dbRef, recH);
    }
    return(true);
}
